#define version "0.5 20.05.2004" 

#include <stdio.h>
#include <unistd.h> 
#include <string.h> 
#include <stdlib.h>
#include <signal.h> 
#include <fcntl.h> 
#include <netdb.h> 
#include <arpa/inet.h> 
#include <sys/time.h>

#define conffile "/etc/niceshaper/config"
#define userfile "/etc/niceshaper/users"
#define pidfile  "/var/run/niceshaper.pid"
#define lockfile "/var/lock/niceshaper.lock"
#define statsfile "/tmp/niceshaper.stats"

enum traftype { download = 1, upload = 2 };
enum tcclassorder { add = 1 , del = 2 };
enum unittype { bps = 8 , kbps = 8192 , mbps = 8388608 , bit = 1 , kbit = 1024 , mbit = 1048576 };

struct userattrib
{
    struct
    {
        char bytes[ 16 ];
        unsigned int speed;
        unsigned int rate;
        unsigned int low;
        unsigned int ceil;
	unsigned int strict;
        unsigned int prio;
    } dl , ul, *up;
    unsigned long int alive;
    char hostname[ 18 ];
    char ip[ 18 ];
    char dev[ 6 ];
    bool work;
};

struct ifaceattrib
{
    char dev[ 6 ];
    char ip[ 16 ];
    char mask[ 16 ];
    char network[ 16 ];
    char broadcast[ 16 ];
    unsigned int bitmask;
};

struct linkattrib
{
    unsigned int linkspeed;
    unsigned int massive;
    unsigned int interactive;
    unsigned int interactive_ceil;
    unsigned int shape;
    unsigned int user_strict;
    unsigned int prio;
    unsigned int low;	
    unsigned int ceil;
    unsigned int max;
    unsigned int handle;
    char bytes[ 16 ];
};

struct useattrib
{
    bool imq;
    bool mark;
    bool none;
    bool resolver;
};

struct statsattrib 
{
    unsigned int dump;
    char path [ 255 ];
    unittype unit;
};

struct userattrib *user;
struct linkattrib *lp;
struct ifaceattrib *iface;
struct linkattrib dl = { 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 2048, "0" };
struct linkattrib ul = { 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 2048, "0" };
struct useattrib use = { false, false, false, false };
struct statsattrib statsconf = { 0 , "" , bit };
//********************************//
unsigned int reload = 0;
unsigned int users = 0;
unsigned int working = 0;
bool router_control = false;
//********************************//
void judge ( int , traftype );
void tcclass ( tcclassorder order , unsigned int );
void signalterm ( int );
void signalusr1 ( int );
void stats ();
void show_stats ();
void init ();
void clean_iptables ();
void iptohostname ( char [] , char [] );
bool do_not_shape ( char [] , char [] );
bool innetwrk ( char [] , char [] , char [] , char [] );
int dotobit ( char [] );
bool bitodot ( char [] , int );
bool getip ( char [] , char [] );
bool split ( char [] , char [] , char [] );
bool valid_dev ( char [] );
bool valid_ip ( char [] );
bool valid_mask ( char [] );
bool valid_port ( int );
bool valid_whiteline ( char [] );
void trim ( char [] );
bool hash ( char [] , char [] );
char *awk( char [] , unsigned int );
char *prioparamawk ( char [] , char [] , unsigned int );
long int unitconvert ( char [] , unittype ); 
long int csubc ( char [] , char[] );
long int power ( int , int );
void help ();
//********************************//
int main ( int argc, char *argv[] )
{
    int dpid, fd;
    unsigned short int statstimer, cycle;
    unsigned long int tts;
    char buf[ 255 ];
    struct timeval now, past;

    if ( argc != 2 ) { help (); exit ( 0 ); }
    if ( !strcmp( argv[ 1 ], "stop" ) ) { if ( access( pidfile, 0 ) ) { printf( "\nNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n" ); exit ( 0 ); }	fd = open( pidfile, 0660 ); dpid = read( fd, buf, 8 ); buf[ dpid ] = '\0'; dpid = atoi( buf ); close ( fd ); kill( dpid, SIGTERM ); unlink( pidfile ); printf("\nquit...\n\n"); exit ( 0 ); }
    if ( !strcmp( argv[ 1 ], "restart" ) ) { if ( access( pidfile, 0 ) ) { printf( "\nNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n" ); exit ( 0 ); } fd = open( pidfile, 0660 ); read( fd, buf, 6 ); dpid = atoi( buf ); close ( fd ); kill( dpid, SIGTERM ); unlink( pidfile ); usleep ( 1000000 ); }
    if ( !strcmp( argv[ 1 ], "stats" ) ) { if ( access( pidfile, 0 ) ) { printf( "\nNiceShaper is not running...( there is not /var/run/niceshaper.pid file)\n\n" ); exit ( 0 ); } else show_stats(); }
    if (  strcmp( argv[ 1 ], "start" ) && strcmp( argv[ 1 ], "restart" ) ) { help (); exit ( 0 ); }
    if ( !access( pidfile, 0 ) ) { printf( "\nNiceShaper alredy running...( there is /var/run/niceshaper.pid file) \n\n" ); exit ( 0 ); }
    if (  access( userfile, R_OK ) ) { printf( "\ncan't read %s file\nquit...\n\n" , userfile ); exit( 0 ); }
    if (  access( conffile, R_OK ) ) { printf( "\ncan't read %s file\nquit...\n\n" , conffile ); exit( 0 ); }

    clean_iptables ();
    init ();
    statstimer = 0;
    printf( "\n\tNiceshaper version:%s\n\thttp://www.niceshaper.mikule.net\n\n", version );
    if ( fork () ) exit ( 0 );
    sprintf ( buf , "%d" , getpid() );
    fd = creat( pidfile, 0660 );
    write( fd , buf , strlen( buf ) );
    close( fd );
    signal( SIGTERM, signalterm );
    signal( SIGUSR1, signalusr1 );
    if ( gettimeofday ( &past , NULL ) == -1 ) { printf( "\ncan't use gettimeofday() function\nquit...\n\n" ); exit( 0 ); }
    while ( true )
    {
        do {
            gettimeofday ( &now , NULL );
	    tts = ( reload + past.tv_sec - now.tv_sec ) * 1000000 + past.tv_usec - now.tv_usec;
            if ( tts > reload * 1000000 ) tts = 1;
        } while ( usleep ( tts ) == -1 );
        gettimeofday ( &now , NULL );
        cycle = now.tv_sec - past.tv_sec;
        gettimeofday ( &past , NULL );
        past.tv_usec = 0;
        if ( dl.linkspeed ) judge( cycle , download );
        if ( ul.linkspeed ) judge( cycle , upload );
	if ( statsconf.dump ) 
	{
	    statstimer++;
    	    if ( statstimer == statsconf.dump ) 
	    {
		signalusr1 ( 0 );
		statstimer = 0;
	    }
	}    
    }
    return 0;
}

void judge ( int cycle_time , traftype traf )
{
    unsigned int n, rateset, quantum;
    unsigned int old_max;
    unsigned long int last_utilize,utilize;
    unsigned long int limit;
    unsigned long int user_utilize;
    unsigned long int user_limit;
    bool judge_sim, overload;
    char buf[ 255 ];
    struct timeval now;
    FILE *pp;

    gettimeofday ( &now , NULL );
    if ( traf == download )
    {
        lp = &dl;
        for ( n = 0 ; n <= users ; n++ ) user[ n ].up = &user[ n ].dl;
        pp = popen( "iptables -t mangle -L niceshaper_dl -vnx", "r" );
    }
    if ( traf == upload )
    {
        lp = &ul;
        for ( n = 0 ; n <= users ; n++ ) user[ n ].up = &user[ n ].ul ;
        pp = popen( "iptables -t mangle -L niceshaper_ul -vnx", "r" );
    }
    do {
	fgets( buf, 255, pp ); 
    } while ( strcmp( awk( buf , 3 ) , "all" ) ); 
    utilize = csubc ( awk ( buf , 2 ) , lp->bytes ) / cycle_time;
    limit = lp->shape / 8;
    strcpy ( lp->bytes , awk ( buf , 2 ) );
    if ( router_control ) n = 0; else n = 1;
    while ( n <= users )
    {
        fgets( buf, 255, pp );
	user[ n ].up->speed = csubc( awk( buf , 2 ) , user[ n ].up->bytes ) * 8 / cycle_time;
        strcpy( user[ n ].up->bytes , awk( buf , 2 ) );
	if ( user[ n ].work )
	{
	    if ( user[ n ].up->speed ) 	user[ n ].alive = now.tv_sec;
	    else if ( ( now.tv_sec - user[ n ].alive ) >= 60 ) tcclass ( del , n );
	}
	else if ( user[ n ].up->speed )
	{
	    tcclass ( add , n );
	    user[ n ].alive = now.tv_sec;
	}
	n++;
    }
    pclose( pp );
    if ( !working ) return;
    judge_sim = false;
    do {
	if ( judge_sim )
	{
	    if ( router_control ) n = 0; else n = 1;
	    last_utilize = utilize;
	    utilize = 0;
    	    while ( n <= users )
	    {
    		if ( user[ n ].work )
    		{
		    if ( user[ n ].up->speed < user[ n ].up->rate ) utilize += user[ n ].up->speed / 8;
		    if ( user[ n ].up->speed >= user[ n ].up->rate ) utilize += user[ n ].up->rate / 8;
		}
		n++;	
	    }	

	}	
	old_max = lp->max;
	if ( utilize < limit )
	{
	    lp->max += ( limit - utilize ) / working * 8;
	    overload = false;
	    if ( lp->max > lp->ceil ) lp->max = lp->ceil;
	}
	else if ( utilize >= limit )
	{
	    lp->max -= lp->max / ( lp->massive / working ) * 1024;
	    overload = true;
	    if ( lp->max < lp->low ) lp->max = lp->low;
	}
	if ( router_control ) n = 0; else n = 1;
	while ( n <= users )
	{
	    if ( user[ n ].work )
	    {
		if ( judge_sim )
		{
		    if ( user[ n ].up->speed < user[ n ].up->rate ) user_utilize = user[ n ].up->speed / 8;
		    if ( user[ n ].up->speed >= user[ n ].up->rate ) user_utilize = user[ n ].up->rate / 8;
	        }
		else user_utilize = user[ n ].up->speed / 8;
	    	user_limit = old_max * user[ n ].up->strict / 100 / 8;

    		if ( user[ n ].up->ceil <= lp->ceil && user[ n ].up->rate > lp->max ) user[ n ].up->rate = lp->max;
	        if ( user[ n ].up->ceil <= lp->ceil && user[ n ].up->rate > user[ n ].up->ceil ) user[ n ].up->rate = user[ n ].up->ceil;
		if ( user[ n ].up->ceil > lp->ceil && lp->max == lp->ceil && user[ n ].up->rate > user[ n ].up->ceil ) user[ n ].up->rate = user[ n ].up->ceil;
    		if ( user[ n ].up->ceil > lp->ceil && lp->max < lp->ceil && user[ n ].up->rate > lp->max ) user[ n ].up->rate = lp->max;
		
		if ( user_utilize >= user_limit && overload ) user[ n ].up->rate -= user[ n ].up->rate / ( lp->massive / working ) * 1024;
		else if ( user_utilize < user_limit && !overload ) user[ n ].up->rate += ( limit - utilize ) / working * 8;
	    }
	    n++;
	}
	if ( overload && utilize != last_utilize ) judge_sim = true;
	else judge_sim = false;
    } while ( judge_sim );

    if ( traf == upload && router_control ) n = 0; else n = 1;
    while ( n <= users )
    {
        if ( user[ n ].work )
        {
	    if ( user[ n ].up->ceil <= lp->ceil && user[ n ].up->rate > lp->max ) user[ n ].up->rate = lp->max;
	    if ( user[ n ].up->ceil <= lp->ceil && user[ n ].up->rate > user[ n ].up->ceil ) user[ n ].up->rate = user[ n ].up->ceil;
	    if ( user[ n ].up->ceil > lp->ceil && lp->max == lp->ceil && user[ n ].up->rate > user[ n ].up->ceil ) user[ n ].up->rate = user[ n ].up->ceil;
	    if ( user[ n ].up->ceil > lp->ceil && lp->max < lp->ceil && user[ n ].up->rate > lp->max ) user[ n ].up->rate = lp->max;
    	    if ( user[ n ].up->rate < user[ n ].up->low ) user[ n ].up->rate = user[ n ].up->low;

            rateset = lp->massive / working;
            if ( user[ n ].up->rate < rateset ) rateset = user[ n ].up->rate;
            quantum = rateset / 8 / 1500;
            if ( !quantum ) quantum = 1;
            if ( traf == download )
            {
                if ( use.imq ) sprintf( buf, "tc class change dev imq1 classid 1:%d htb rate %d ceil %d prio %d quantum %d", n + 1000, rateset, user[ n ].dl.rate, user[ n ].dl.prio, quantum );
                else if ( use.mark || use.none ) sprintf( buf, "tc class change dev %s classid 1:%d htb rate %d ceil %d prio %d quantum %d", user[ n ].dev, n + 1000, rateset, user[ n ].dl.rate, user[ n ].dl.prio, quantum );
            }
            else if ( traf == upload )
            {
                if ( use.imq ) sprintf( buf, "tc class change dev imq0 classid 1:%d htb rate %d ceil %d prio %d quantum %d", n + 1000, rateset, user[ n ].ul.rate, user[ n ].ul.prio, quantum );
                else if ( use.mark || use.none ) sprintf( buf, "tc class change dev %s classid 1:%d htb rate %d ceil %d prio %d quantum %d", iface[ 0 ].dev, n + 1000, rateset, user[ n ].ul.rate, user[ n ].ul.prio, quantum );
            }
            system( buf );
        }
        n++;
    }
}

void tcclass ( tcclassorder order , unsigned int n )
{
    int rateset, quantum;
    char buf[ 150 ], dev[ 6 ];

    if ( n > users ) return; 
    if ( order == add )
    {
        user[ n ].work = true;
        user[ n ].dl.rate = dl.max;
        user[ n ].ul.rate = ul.max;
        working++;
    }
    else if ( order == del )
    {
        user[ n ].work = false;
	working--;
    }
    if ( dl.linkspeed && n )
    {
        if ( use.imq ) strcpy( dev , "imq1" ); 
	else if ( use.none || use.mark ) strcpy( dev , user[ n ].dev );
	if ( order == add ) 
	{
    	    rateset = dl.massive / users;
	    quantum = rateset / 8 / 1500;
    	    if ( !quantum ) quantum = 1;
	    sprintf( buf, "tc class add dev %s parent 1:10 classid 1:%d htb rate %d ceil %d prio %d quantum %d", dev, n + 1000, rateset, rateset, user[ n ].dl.prio, quantum );
	    system( buf );
	    sprintf( buf, "tc qdisc add dev %s parent 1:%d handle %d: sfq", dev, n + 1000, n + 1000 );
    	    system( buf );
    	    sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32 match ip dst %s flowid 1:%d", dev, dl.handle + n, user[ n ].ip, n + 1000 );
    	    system( buf );
	}    
	else if ( order == del )
	{
	    sprintf( buf, "tc filter del dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32", dev, dl.handle + n );
    	    system( buf );
    	    sprintf( buf, "tc qdisc del dev %s parent 1:%d", dev, n + 1000 );
    	    system( buf );
    	    sprintf( buf, "tc class del dev %s classid 1:%d", dev, n + 1000 );
    	    system( buf );
	}
    }
    if ( ul.linkspeed )
    {
        if ( use.imq ) strcpy( dev , "imq0" );
        else if ( use.none || use.mark ) strcpy( dev , iface[ 0 ].dev );
        if ( order == add )
	{
	    rateset = ul.massive / users;
    	    quantum = rateset / 8 / 1500;
	    if ( !quantum ) quantum = 1;
	    sprintf( buf, "tc class add dev %s parent 1:10 classid 1:%d htb rate %d ceil %d prio %d quantum %d", dev, n + 1000, rateset, rateset, user[ n ].ul.prio, quantum );
    	    system( buf );
    	    sprintf( buf, "tc qdisc add dev %s parent 1:%d handle %d: sfq", dev, n + 1000, n + 1000 );
	    system( buf );
    	    if ( use.mark )
    	    {
    		sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle %d fw flowid 1:%d", dev, ul.handle + n, n + 1000 );
        	system( buf );
    	    }
    	    else if ( use.none || use.imq ) 
    	    {
        	sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32 match ip src %s flowid 1:%d", dev, ul.handle + n, user[ n ].ip, n + 1000 );
        	system( buf );
    	    }
	}
	else if ( order == del )
	{
	    if ( use.mark )
    	    {
        	sprintf( buf, "tc filter del dev %s protocol ip parent 1:0 prio 10 handle %d fw", dev, ul.handle + n );
        	system( buf );
    	    }
    	    else if ( use.none || use.imq ) 
    	    {
        	sprintf( buf, "tc filter del dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32", dev, ul.handle + n );
        	system( buf );
    	    }
    	    sprintf( buf, "tc qdisc del dev %s parent 1:%d", dev, n + 1000 );
	    system( buf );
    	    sprintf( buf, "tc class del dev %s classid 1:%d", dev, n + 1000 );
	    system( buf );
	}
    }
}

void signalterm ( int syg )
{
    int n;
    char buf[ 255 ];

    clean_iptables ();
    if ( use.imq )
    {
        if ( dl.linkspeed ) 
	{	
	    system( "tc qdisc del root dev imq1 2> /dev/null > /dev/null" );
	    system( "ip link set imq1 down 2> /dev/null > /dev/null" );
	}    
        if ( ul.linkspeed ) 
	{
	    system( "tc qdisc del root dev imq0 2> /dev/null > /dev/null" );
	    system( "ip link set imq0 down 2> /dev/null > /dev/null" );
	}    
    }
    else if ( ( use.mark ) || ( use.none ) )
    {
	if ( !ul.linkspeed ) n = 1;
	else n = 0;
	while ( strcmp( iface[ n ].dev, "EOF" ) )
	{
	    sprintf( buf, "tc qdisc del root dev %s 2> /dev/null > /dev/null", iface[ n ].dev );
            system( buf );
            n++;
    	}
    }
    unlink( pidfile );
    exit ( 0 );
}

void clean_iptables ()
{
    int n;
    char buf[ 255 ];
    FILE *pp;
    pp = popen( "iptables -t mangle -L PREROUTING -n", "r" );
    n = 0;
    while ( fgets( buf, 255, pp ) )
    {
	n++;
	if ( !strcmp ( awk ( buf , 1 ) , "niceshaper_ul" ) ) 
	{
	    sprintf( buf, "iptables -t mangle -D PREROUTING %d", n - 2 );
	    system( buf );
	    n--;
	}
    }
    pclose( pp );
    pp = popen( "iptables -t mangle -L POSTROUTING -n", "r" );
    n = 0;
    while ( fgets( buf, 255, pp ) )
    {
	n++;
	if ( !strcmp ( awk ( buf , 1 ) , "niceshaper_dl" ) ) 
	{
	    sprintf( buf, "iptables -t mangle -D POSTROUTING %d", n - 2 );
	    system( buf );
	    n--;
	}
    }
    pclose( pp );
    pp = popen( "iptables -t mangle -L INPUT -n", "r" );
    n = 0;    
    while ( fgets( buf, 255, pp ) )
    {
	n++;
	if ( !strcmp ( awk ( buf , 1 ) , "niceshaper_dl" ) ) 
	{
	    sprintf( buf, "iptables -t mangle -D INPUT %d", n - 2 );
	    system( buf );
	    n--;
	}
    }
    pclose( pp );
    pp = popen( "iptables -t mangle -L OUTPUT -n", "r" );
    n = 0;
    while ( fgets( buf, 255, pp ) )
    {
	n++;
	if ( !strcmp ( awk ( buf , 1 ) , "niceshaper_ul" ) ) 
	{
	    sprintf( buf, "iptables -t mangle -D OUTPUT %d", n - 2 );
	    system( buf );
	    n--;
	}
    }
    pclose( pp );
    system( "iptables -t mangle -F niceshaper_dl 2> /dev/null > /dev/null" );
    system( "iptables -t mangle -F niceshaper_ul 2> /dev/null > /dev/null" );
    system( "iptables -t mangle -X niceshaper_dl 2> /dev/null > /dev/null" );
    system( "iptables -t mangle -X niceshaper_ul 2> /dev/null > /dev/null" );
}

void signalusr1 ( int syg )
{
    unsigned int n, fd;
    char buf[ 81 ] = "", bufdl[ 33 ] = "", buful [ 33 ] = "";
    signal( SIGUSR1, signalusr1 );
    
    if ( syg ) fd = creat( statsfile, 0666 );
    else fd = creat( statsconf.path, 0666 );
    if ( router_control ) n = 0; else n = 1;
    sprintf( buf, "HOST              DOWNLOAD   (       UTILIZE )        UPLOAD   (       UTILIZE )\n" );
    write( fd, buf, strlen( buf ) );
    while ( n <= users )
    {
        if ( user[ n ].work )
        {
	    if ( statsconf.unit == bit )
	    {
	        sprintf( bufdl, "%10dbit - ( %10dbit )", user[ n ].dl.rate, user[ n ].dl.speed );
	        sprintf( buful, "%10dbit - ( %10dbit )", user[ n ].ul.rate, user[ n ].ul.speed );
	    }
	    else if ( statsconf.unit == kbit )
	    {
	        sprintf( bufdl, "%9dkbit - ( %9dkbit )", user[ n ].dl.rate / statsconf.unit, user[ n ].dl.speed / statsconf.unit );
	        sprintf( buful, "%9dkbit - ( %9dkbit )", user[ n ].ul.rate / statsconf.unit, user[ n ].ul.speed / statsconf.unit );
	    }
	    else if ( statsconf.unit == mbit )
	    {
	        sprintf( bufdl, "%9.2fmbit - ( %9.2fmbit )", float( user[ n ].dl.rate ) / statsconf.unit, float( user[ n ].dl.speed ) / statsconf.unit );
	        sprintf( buful, "%9.2fmbit - ( %9.2fmbit )", float( user[ n ].ul.rate ) / statsconf.unit, float( user[ n ].ul.speed ) / statsconf.unit );
	    }
	    else if ( statsconf.unit == bps )
	    {
	        sprintf( bufdl, "%10dbps - ( %10dbps )", user[ n ].dl.rate / statsconf.unit, user[ n ].dl.speed / statsconf.unit );
	        sprintf( buful, "%10dbps - ( %10dbps )", user[ n ].ul.rate / statsconf.unit, user[ n ].ul.speed / statsconf.unit );
	    }
	    else if ( statsconf.unit == kbps )
	    {
	        sprintf( bufdl, "%9.1fkbps - ( %9.1fkbps )", float( user[ n ].dl.rate ) / statsconf.unit, float( user[ n ].dl.speed ) / statsconf.unit );
	        sprintf( buful, "%9.1fkbps - ( %9.1fkbps )", float( user[ n ].ul.rate ) / statsconf.unit, float( user[ n ].ul.speed ) / statsconf.unit );
	    }
	    else if ( statsconf.unit == mbps )
	    {
	        sprintf( bufdl, "%9.2fmbps - ( %9.2fmbps )", float( user[ n ].dl.rate ) / statsconf.unit, float( user[ n ].dl.speed ) / statsconf.unit );
	        sprintf( buful, "%9.2fmbps - ( %9.2fmbps )", float( user[ n ].ul.rate ) / statsconf.unit, float( user[ n ].ul.speed ) / statsconf.unit );
	    }
	    bufdl[ strlen( bufdl ) ] = '\0';
	    buful[ strlen( buful ) ] = '\0';
	    if ( !dl.linkspeed || !n )
	    {
		sprintf( buf, "%-12.12s                                   %s\n", user[ n ].hostname, buful);
	    }
	    else if ( !ul.linkspeed )
	    {
		sprintf( buf, "%-12.12s %s\n", user[ n ].hostname, bufdl );
	    }
	    else
	    {
		sprintf( buf, "%-12.12s %s %s\n", user[ n ].hostname, bufdl, buful);
	    }
	    write( fd, buf, strlen( buf ) );
        }
        n++;
    }
    if ( !syg )
    {
	strcpy( buf , "\n                                                           Povered by NiceShaper" );
	write( fd, buf, strlen( buf ) );
    }
    close( fd );
    if ( !access( lockfile, 0 ) ) unlink( lockfile );
}

void show_stats ()
{
    int fd;
    char buf[ 10 ];
    FILE *fp;
    fp = fopen( pidfile, "r" );
    fgets( buf, 9, fp );
    fclose ( fp );
    creat ( lockfile, 0660 );
    kill ( atoi( buf ), SIGUSR1 );
    while ( !access( lockfile, 0 ) );
    fd = open( statsfile, 0660 );
    while ( read( fd, buf, 1 ) ) printf( "%c", buf[ 0 ] );
    close( fd );
    unlink( statsfile );
    exit ( 0 );
}

void init ()
{
    unsigned int n;
    char buf[ 255 ] = "", buf2[ 255 ] = "", option[ 35 ] = "", dev[ 6 ] = "", addr1[ 35 ] = "", addr2[ 35 ] = "";
    unsigned long addr , mssk;
    struct in_addr broadcst , netwrk;
    struct {
        int set;
        int end;
    } dlpos , ulpos , glpos , *posptr;
    traftype traf;
    FILE *fp; 

    fp = fopen( conffile, "r" );
    while ( fgets( buf, 255, fp ) )
    {
	hash( buf , "#" );
        strcpy( option, awk( buf, 1 ) );
        if ( !strcmp( option, "<global>" ) ) glpos.set = ftell( fp ) - 9;
        if ( !strcmp( option, "</global>" ) ) glpos.end = ftell( fp ) - 10;
        if ( !strcmp( option, "<download>" ) ) dlpos.set = ftell( fp ) - 11;
        if ( !strcmp( option, "</download>" ) ) dlpos.end = ftell( fp ) - 12;
        if ( !strcmp( option, "<upload>" ) ) ulpos.set = ftell( fp ) - 9;
        if ( !strcmp( option, "</upload>" ) ) ulpos.end = ftell( fp ) - 10;
    }
    if ( glpos.set >= glpos.end ) { printf( "\ncheck your %s file\nquit...\n\n" , conffile ); exit ( 0 ); }
    if ( dlpos.set >= dlpos.end ) { printf( "\ncheck your %s file\nquit...\n\n" , conffile ); exit ( 0 ); }
    if ( ulpos.set >= ulpos.end ) { printf( "\ncheck your %s file\nquit...\n\n" , conffile ); exit ( 0 ); }
    traf = download;
    do {
        if ( traf == download ) 
	{ 
	    lp = &ul; 
	    posptr = &ulpos; 
	    traf = upload;
	}
        else if ( traf == upload ) 
	{ 
	    lp = &dl; 
	    posptr = &dlpos; 
	    traf = download;
	}
        fseek( fp, posptr->set, SEEK_SET );
        while ( ftell( fp ) < posptr->end )
        {
            fgets( buf, 255, fp );
	    trim( buf );
	    hash( buf , "#" );
            strcpy( option, awk( buf, 1 ) );
	    if ( !strcmp( option , "link" ) )
            {
                if ( strstr( buf, "speed" ) ) lp->linkspeed = unitconvert( awk( strstr( buf, "speed" ), 2 ) , bit );
                if ( strstr( buf, "shape" ) ) lp->shape = unitconvert( awk( strstr( buf, "shape" ), 2 ) , bit );
            }
	    else if ( !strcmp( option , "user" ) )
            {
                if ( strstr( buf, "low" ) ) lp->low = unitconvert( awk( strstr( buf, "low" ), 2 ) , bit );
                if ( strstr( buf, "ceil" ) ) lp->ceil = unitconvert( awk( strstr( buf, "ceil" ), 2 ) , bit );
                if ( strstr( buf, "strict" ) ) lp->user_strict = atoi( awk( strstr( buf, "strict" ), 2 ) );
                if ( strstr( buf, "prio" ) ) lp->prio = atoi( awk( strstr( buf, "prio" ), 2 ) );
            }
            else if ( !strcmp( option , "interactive" ) )
            {
                if ( strstr( buf, "rate" ) ) lp->interactive = unitconvert( awk( strstr( buf, "rate" ), 2 ) , bit );
                if ( strstr( buf, "ceil" ) ) lp->interactive_ceil = unitconvert( awk( strstr( buf, "ceil" ), 2 ) , bit );
            }
            else if ( !strcmp( option, "policy" ) )
            {
                if ( strstr( buf , "off" ) ) lp->linkspeed = 0;
            }
        }
	if ( !lp->linkspeed ) { printf( "\nput your link speed in %s file\nquit...\n\n", conffile ); exit ( 0 ); }
        if ( !lp->shape ) lp->shape = lp->linkspeed * 85 / 100;
        if ( !lp->user_strict ) lp->user_strict = 80;
        if ( !lp->prio ) lp->prio = 5;
        if ( !lp->ceil ) lp->ceil = lp->linkspeed - lp->interactive;
        if ( lp->interactive > lp->linkspeed ) lp->interactive = 0;
        if ( lp->interactive > lp->interactive_ceil ) lp->interactive = lp->interactive_ceil;
        if ( lp->low > lp->linkspeed ) lp->low = 0 ;
        if ( lp->ceil > lp->linkspeed ) lp->ceil = lp->linkspeed - lp->interactive;
	if ( lp->user_strict > 100 ) { printf( "\nuser strict must be between 0-100%%\nquit...\n\n" ); exit ( 0 ); }
	if ( lp->prio >= 8 ) { printf( "\nprio must be between 0 - 7\nquit...\n" ); exit ( 0 ); }
        lp->massive = lp->linkspeed - lp->interactive;
        lp->max = lp->ceil;
    } while ( traf == upload );
    if ( !dl.linkspeed && !ul.linkspeed ) { printf( "\nboth download and upload disabled\nquit...\n\n" ); exit ( 0 ); }
    fseek( fp, glpos.set, SEEK_SET );
    while ( ftell( fp ) < glpos.end )
    {
        fgets( buf, 255, fp );
	trim( buf );
	hash( buf , "#" );
        strcpy( option, awk( buf, 1 ) );
	if ( !strcmp( option , "resolve" ) )
        {
            if ( strstr( buf, "hostname" ) )
            {
                if ( !strcmp ( awk( strstr( buf , "hostname" ) , 2 ) , "true" ) ) use.resolver = true;
            }
        }
	else if ( !strcmp( option , "method" ) )
        {
            if ( strstr( buf , "imq" ) ) use.imq = true;
            else if ( strstr( buf , "mark" ) ) use.mark = true;
            else if ( strstr( buf , "none" ) ) use.none = true;
        }
	else if ( !strcmp( option , "stats" ) )
        {
	    if ( strstr( buf, "unit" ) )
            {
		if ( !strcmp( awk( strstr( buf , "unit" ) , 2 ) , "kbit" ) ) statsconf.unit = kbit;
		else if ( !strcmp( awk( strstr( buf , "unit" ) , 2 ) , "mbit" ) ) statsconf.unit = mbit;
		else if ( !strcmp( awk( strstr( buf , "unit" ) , 2 ) , "bit" ) ) statsconf.unit = bit;
		else if ( !strcmp( awk( strstr( buf , "unit" ) , 2 ) , "kbps" ) ) statsconf.unit = kbps;
		else if ( !strcmp( awk( strstr( buf , "unit" ) , 2 ) , "mbps" ) ) statsconf.unit = mbps;
		else if ( !strcmp( awk( strstr( buf , "unit" ) , 2 ) , "bps" ) ) statsconf.unit = bps;
		else statsconf.unit = bit;
	    }
	    if ( strstr( buf, "dump" ) )
            {
		statsconf.dump = atoi( awk( strstr( buf , "dump" ) , 2 ) );
	    }
	    if ( strstr( buf, "file" ) )
            {
    		strcpy( statsconf.path , awk( strstr( buf , "file" ) , 2 ) );
	    }
	}
	else if ( !strcmp( option, "reload" ) ) reload = atoi( awk( buf , 2 ) );
    }
    if ( !use.none && !use.mark && !use.imq ) use.none = true;
    if ( !reload ) reload = 5 ;
    fclose( fp );
    fp = fopen( userfile, "r" );
    while ( fgets( buf, 255, fp ) ) 
    {
        trim( buf );
        hash( buf , "#" );
	if ( valid_ip( awk( buf , 1 ) ) ) if ( valid_dev( awk( buf , 2 ) ) ) users++;
    }	
    n = users + 2;
    user = new userattrib[ n ];
    do {
	n--;
	strcpy( user[ n ].dl.bytes , "" );
	strcpy( user[ n ].ul.bytes , "" );
	strcpy( user[ n ].ip , "" );
	strcpy( user[ n ].hostname , "" );
	strcpy( user[ n ].dev , "" );
	user[ n ].work = false;
    } while ( n );
    fseek( fp, 0, SEEK_SET );
    n = 0;
    while ( fgets( buf, 255 , fp ) )
    {
	n++;
	trim( buf );
        hash( buf , "#" );
	if ( valid_whiteline( buf ) ) { n--; continue; }
	strcpy( user[ n ].ip, awk( buf, 1 ) );
        strcpy( user[ n ].dev, awk( buf, 2 ) );
	if ( !valid_ip( user[ n ].ip ) ) { printf("This is not correct IP ADDRESS:'%s'\nCheck your %s file\nquit...\n\n", user[ n ].ip, userfile );  exit( 0 ); }
	if ( !valid_dev( user[ n ].dev ) ) { printf("This is not correct interface device:'%s'\nCheck your %s file\nquit...\n\n", user[ n ].dev, userfile );  exit( 0 ); }
	if ( use.resolver ) iptohostname( user[ n ].hostname , user[ n ].ip );
        else strcpy( user[ n ].hostname, user[ n ].ip );
        user[ n ].dl.rate = dl.ceil;
        user[ n ].ul.rate = ul.ceil;
        user[ n ].dl.low = dl.low;
        user[ n ].ul.low = ul.low;
        user[ n ].dl.ceil = dl.ceil;
        user[ n ].ul.ceil = ul.ceil;
	user[ n ].dl.strict = dl.user_strict;
	user[ n ].ul.strict = ul.user_strict;
        user[ n ].dl.prio = dl.prio;
        user[ n ].ul.prio = ul.prio;
        if ( strstr( buf, "dl_rate" ) )
        {
            user[ n ].dl.low = unitconvert( awk( strstr( buf , "dl_rate" ) , 2 ) , bit );
            user[ n ].dl.ceil = unitconvert( awk( strstr( buf , "dl_rate" ) , 2 ) , bit );
        }
        if ( strstr( buf, "ul_rate" ) )
        {
            user[ n ].ul.low = unitconvert( awk( strstr( buf , "ul_rate" ) , 2 ) , bit );
            user[ n ].ul.ceil = unitconvert( awk( strstr( buf , "ul_rate" ) , 2 ) , bit );
        }
        if ( strstr( buf, "dl_low" ) ) user[ n ].dl.low = unitconvert( awk( strstr( buf , "dl_low" ) , 2 ) , bit );
        if ( strstr( buf, "dl_ceil" ) ) user[ n ].dl.ceil = unitconvert( awk( strstr( buf , "dl_ceil" ) , 2 ) , bit );
        if ( strstr( buf, "ul_low" ) ) user[ n ].ul.low = unitconvert( awk( strstr( buf , "ul_low" ) , 2 ) , bit );
        if ( strstr( buf, "ul_ceil" ) ) user[ n ].ul.ceil = unitconvert( awk( strstr( buf , "ul_ceil" ) , 2 ) , bit );
        if ( strstr( buf, "dl_strict" ) ) user[ n ].dl.strict = atoi( awk( strstr( buf , "dl_strict" ) , 2 ) );
        if ( strstr( buf, "ul_strict" ) ) user[ n ].ul.strict = atoi( awk( strstr( buf , "ul_strict" ) , 2 ) );
        if ( strstr( buf, "dl_prio" ) ) user[ n ].dl.prio = atoi( awk( strstr( buf , "dl_prio" ) , 2 ) );
        if ( strstr( buf, "ul_prio" ) ) user[ n ].ul.prio = atoi( awk( strstr( buf , "ul_prio" ) , 2 ) );
        if ( user[ n ].dl.low > dl.linkspeed ) user[ n ].dl.low = dl.low;
        if ( user[ n ].ul.low > ul.linkspeed ) user[ n ].ul.low = ul.low;
        if ( user[ n ].dl.ceil > dl.linkspeed ) user[ n ].dl.ceil = dl.ceil;
        if ( user[ n ].ul.ceil > ul.linkspeed ) user[ n ].ul.ceil = ul.ceil;
        if ( user[ n ].dl.low > user[ n ].dl.ceil ) user[ n ].dl.low = user[ n ].dl.ceil;
        if ( user[ n ].ul.low > user[ n ].ul.ceil ) user[ n ].ul.low = user[ n ].ul.ceil;
        if ( user[ n ].dl.strict > 100 ) user[ n ].dl.strict = dl.user_strict;
        if ( user[ n ].ul.strict > 100 ) user[ n ].ul.strict = ul.user_strict;
        if ( user[ n ].dl.prio >= 8 ) user[ n ].dl.prio = 5;
        if ( user[ n ].ul.prio >= 8 ) user[ n ].ul.prio = 5;
    }
    fclose( fp );
    fp = fopen( conffile, "r" );
    fseek( fp, glpos.set, SEEK_SET );
    n = 0;
    while ( ftell( fp ) < glpos.end )
    {
        fgets( buf, 255, fp );
	trim( buf );
	hash( buf , "#" );
        strcpy( option, awk( buf, 1 ) );
        if ( !strcmp( option , "iface" ) ) n++;
    }
    n += 2;
    iface = new ifaceattrib[ n ];
    do {
    	n--;
	strcpy( iface[ n ].dev , "EOF" );
	strcpy( iface[ n ].ip , "" );
	strcpy( iface[ n ].mask , "" );
	strcpy( iface[ n ].network , "" );
	strcpy( iface[ n ].broadcast , "" );
	iface[ n ].bitmask = 32;
    } while ( n );
    fseek( fp, glpos.set, SEEK_SET );
    while ( ftell( fp ) < glpos.end )
    {
        fgets( buf, 255, fp );
	trim( buf );
	hash( buf , "#" );
        strcpy( option, awk( buf, 1 ) );
	if ( !strcmp( option , "iface" ) )
        {
    	    if ( strstr( buf , "inet" ) )
    	    {
                n = 0;
                strcpy( iface[ n ].dev , awk( strstr ( buf , "inet" ) , 2 ) );
                strcpy( buf2, awk( strstr ( buf , "inet" ) , 3 ) );
		if ( !strcmp( buf2 , "auto" ) ) if ( !getip ( buf2 , iface[ 0 ].dev ) ) { printf( "IP command not found or device %s does not exist\nquit...\n\n" , iface[ n ].dev ); exit( 0 ); }
    	    }
    	    else if ( strstr( buf , "local" ) )
    	    {
		n = 1;
                while ( strcmp( iface[ n ].dev , "EOF" ) ) n++;
        	strcpy( iface[ n ].dev , awk( strstr ( buf , "local" ) , 2 ) );
            	strcpy( buf2, awk( strstr ( buf , "local" ) , 3 ) );
    	    }	
	    if ( !split ( iface[ n ].ip , iface[ n ].mask , buf2 ) ) { printf("Check your iface directives\nquit...\n\n");  exit( 0 ); }
	    if ( !valid_dev( iface[ n ].dev ) ) { printf("Check your iface directives\nquit...\n\n");  exit( 0 ); }
	    iface[ n ].bitmask = dotobit( iface[ n ].mask );
	    addr = ntohl( inet_addr( iface[ n ].ip ) );
    	    mssk = ntohl( inet_addr( iface[ n ].mask ) );
    	    netwrk.s_addr = htonl( addr & mssk );
    	    broadcst.s_addr = htonl( ( addr & mssk ) | ~mssk );
    	    strcpy ( iface[ n ].network , inet_ntoa( netwrk ) );
    	    strcpy ( iface[ n ].broadcast , inet_ntoa( broadcst ) );
	}
	else if ( !strcmp( option , "shape" ) )
        {
    	    if ( !strcmp( awk( strstr( buf , "shape" ) , 2 ) , "router" ) )
            {
		if ( !strcmp( awk( strstr( buf , "router" ) , 2 ) , "true" ) ) router_control = true;
                if ( strstr( buf, "low" ) ) user[ 0 ].ul.low = unitconvert( awk( strstr( buf, "low" ), 2 ) , bit );
                if ( strstr( buf, "ceil" ) ) user[ 0 ].ul.ceil = unitconvert( awk( strstr( buf, "ceil" ), 2 ) , bit );
                if ( strstr( buf, "prio" ) ) user[ 0 ].ul.prio = atoi( awk( strstr( buf, "prio" ), 2 ) );
            }
        }
    }
    if ( !user[ 0 ].ul.low ) user[ 0 ].ul.low = ul.low;
    if ( !user[ 0 ].ul.ceil ) user[ 0 ].ul.ceil = ul.ceil;
    if ( user[ 0 ].ul.prio > 7 ) user[ 0 ].ul.prio = 5;
    if ( user[ 0 ].ul.low > ul.linkspeed ) user[ 0 ].ul.low = 0;
    if ( user[ 0 ].ul.ceil > ul.linkspeed ) user[ 0 ].ul.ceil = ul.ceil;
    strcpy( user[ 0 ].ip, iface[ 0 ].ip );
    strcpy( user[ 0 ].dev, iface[ 0 ].dev );
    if ( use.resolver ) strcpy( user[ 0 ].hostname , "localhost" );
    else strcpy( user[ 0 ].hostname, user[ 0 ].ip );
    if ( !use.imq && strcmp( iface[ 2 ].dev , "EOF" ) )	{ dl.interactive = 0; dl.interactive_ceil = 0; ul.interactive = 0; ul.interactive_ceil = 0; }
    if ( dl.linkspeed )
    {
        n = 1;
        if ( use.imq ) system ( "ip link set imq1 up 2> /dev/null > /dev/null" );
        system( "iptables -t mangle -N niceshaper_dl" );
        if ( router_control )
        {
            sprintf( buf, "iptables -t mangle -I INPUT -i %s -d %s -j niceshaper_dl", iface[ 0 ].dev, iface[ 0 ].ip );
            system( buf );
        }
        while ( strcmp( iface[ n ].dev, "EOF" ) )
        {
            sprintf( buf, "iptables -t mangle -I POSTROUTING -o %s -d %s/%s -j niceshaper_dl", iface[ n ].dev, iface[ n ].network, iface[ n ].mask );
            system( buf );
            n++;
        }
    }
    if ( ul.linkspeed )
    {
        n = 1;
        if ( use.imq ) system ( "ip link set imq0 up 2> /dev/null > /dev/null" );
        system( "iptables -t mangle -N niceshaper_ul" );
        if ( router_control )
        {
            sprintf( buf, "iptables -t mangle -I OUTPUT -o %s -s %s -j niceshaper_ul", iface[ 0 ].dev, iface[ 0 ].ip );
            system( buf );
        }
        while ( strcmp( iface[ n ].dev, "EOF" ) )
        {
            sprintf( buf, "iptables -t mangle -A PREROUTING -i %s -s %s/%s -j niceshaper_ul", iface[ n ].dev, iface[ n ].network, iface[ n ].mask );
            system( buf );
            n++;
        }
    }
    if ( dl.linkspeed ) system ( "iptables -t mangle -A niceshaper_dl" );
    if ( ul.linkspeed ) system ( "iptables -t mangle -A niceshaper_ul" );
    if ( use.imq )
    {
        if ( dl.linkspeed )
        {
	    system( "tc qdisc del root dev imq1 2> /dev/null > /dev/null" );
            system( "tc qdisc add dev imq1 root handle 1: htb default 10" );
            sprintf( buf, "tc class add dev imq1 parent 1: classid 1:10 htb rate %d", dl.linkspeed );
            system( buf );
            if ( dl.interactive )
            {
                sprintf( buf, "tc class add dev imq1 parent 1:10 classid 1:100 htb rate %d ceil %d prio 0 quantum %d", dl.interactive, dl.interactive_ceil, dl.interactive / 8 / 1500 );
                system( buf );
                system( "tc qdisc add dev imq1 parent 1:100 handle 100: sfq" );
            }
        }
        if ( ul.linkspeed )
        {
	    system( "tc qdisc del root dev imq0 2> /dev/null > /dev/null" );
            system( "tc qdisc add dev imq0 root handle 1: htb default 10" );
            sprintf( buf, "tc class add dev imq0 parent 1: classid 1:10 htb rate %d", ul.linkspeed );
            system( buf );
            if ( ul.interactive )
            {
                sprintf( buf, "tc class add dev imq0 parent 1:10 classid 1:100 htb rate %d ceil %d prio 0 quantum %d", ul.interactive, ul.interactive_ceil, ul.interactive / 8 / 1500 );
                system( buf );
                system( "tc qdisc add dev imq0 parent 1:100 handle 100: pfifo" );
            }
        }
    }
    else if ( ( use.mark ) || ( use.none ) )
    {
        if ( dl.linkspeed )
        {
	    n = 1;
            while ( strcmp( iface[ n ].dev, "EOF" ) )
            {
		sprintf( buf, "tc qdisc del root dev %s 2> /dev/null > /dev/null", iface [ n ].dev );
		system( buf );
        	sprintf( buf, "tc qdisc add dev %s root handle 1: htb default 10", iface[ n ].dev );
        	system( buf );
        	sprintf( buf, "tc class add dev %s parent 1: classid 1:1 htb rate 100mbit", iface[ n ].dev );
        	system( buf );
        	sprintf( buf, "tc class add dev %s parent 1:1 classid 1:10 htb rate %d", iface[ n ].dev, dl.linkspeed );
        	system( buf );
                n++;
            }
            if ( dl.interactive )
            {
                sprintf( buf, "tc class add dev %s parent 1:10 classid 1:100 htb rate %d ceil %d prio 0 quantum %d", iface[ 1 ].dev, dl.interactive, dl.interactive_ceil, dl.interactive / 8 / 1500 );
                system( buf );
                sprintf( buf, "tc qdisc add dev %s parent 1:100 handle 100: sfq", iface[ 1 ].dev );
                system( buf );
            }
        }
        if ( ul.linkspeed )
        {
	    sprintf( buf, "tc qdisc del root dev %s 2> /dev/null > /dev/null", iface [ 0 ].dev );
	    system( buf );
            sprintf( buf, "tc qdisc add dev %s root handle 1: htb default 10", iface[ 0 ].dev );
            system( buf );
            sprintf( buf, "tc class add dev %s parent 1: classid 1:10 htb rate %d", iface[ 0 ].dev, ul.linkspeed );
            system( buf );
            if ( ul.interactive )
            {
                sprintf( buf, "tc class add dev %s parent 1:10 classid 1:100 htb rate %d ceil %d prio 0 quantum %d", iface[ 0 ].dev, ul.interactive, ul.interactive_ceil, ul.interactive / 8 / 1500 );
                system( buf );
                sprintf( buf, "tc qdisc add dev %s parent 1:100 handle 100: sfq", iface[ 0 ].dev );
                system( buf );
            }
        }
    }
    fseek( fp, glpos.set, SEEK_SET );
    while ( ftell( fp ) < glpos.end )
    {
        fgets( buf, 255, fp );
	trim( buf );
        hash( buf , "#" );
        strcpy( option, awk( buf, 1 ) );
	if ( !strcmp( option, "do" ) )
        {
            if ( !strcmp( awk ( buf , 2 ) , "not" ) )
            {
                if ( !strcmp( awk ( buf , 3 ) , "shape" ) )
                {
                    if ( !strcmp( awk ( buf , 4 ) , "local" ) )
                    {
        	        if ( !strcmp( awk ( buf , 6 ) , "with" ) )
    	    	        {
                	    strcpy( addr1, awk( buf, 5 ) );
                    	    strcpy( addr2, awk( buf, 7 ) );
			    if ( !do_not_shape ( addr1 , addr2 ) ) { printf("Check your 'do not shape local' directives\n\nquit...\n"); exit(0); }
			}	
                    }
                }
            }
        }
    }
    if ( dl.interactive )
    {
        fseek( fp , dlpos.set , SEEK_SET );
        if ( use.imq ) strcpy ( dev , "imq1" );
        else strcpy ( dev , iface[ 1 ].dev );
        while ( ftell( fp ) < dlpos.end )
        {
            fgets( buf , 255 , fp );
	    trim( buf );
	    hash( buf , "#" );
            strcpy( option, awk( buf, 1 ) );
            if ( !strcmp( option, "interactive" ) )
            {
                if ( strstr( buf, "srcport" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "srcport" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, dl.handle, prioparamawk ( buf , "srcport" , n ) );
                        system( buf2 );
                        dl.handle++;
                    }
                }
                if ( strstr( buf, "dstport" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "dstport" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, dl.handle, prioparamawk ( buf , "dstport" , n ) );
                        system( buf2 );
                        dl.handle++;
                    }
                }
                if ( strstr( buf, "srcip" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "srcip" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, dl.handle, prioparamawk ( buf , "srcip" , n ) );
                        system( buf2 );
                        dl.handle++;
                    }
                }
                if ( strstr( buf, "dstip" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "dstip" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, dl.handle, prioparamawk ( buf , "dstip" , n ) );
                        system( buf2 );
                        dl.handle++;
                    }
                }
                if ( strstr( buf, "u32" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "u32" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, dl.handle, prioparamawk ( buf , "u32" , n ) );
                        system( buf2 );
                        dl.handle++;
                    }
                }
            }
        }
    }
    if ( ul.interactive && use.mark )
    {
        sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle %d fw flowid 1:%d", iface[ 0 ].dev, ul.handle, 100 );
        system( buf );
        ul.handle++;
    }
    else if ( ul.interactive && !use.mark )
    {
        fseek( fp , ulpos.set , SEEK_SET );
        if ( use.imq ) strcpy ( dev , "imq0" );
        else if ( use.none ) strcpy ( dev , iface[ 0 ].dev );
        while ( ftell( fp ) < ulpos.end )
        {
            fgets( buf , 255 , fp );
	    trim ( buf );
	    hash( buf , "#" );
            strcpy( option, awk( buf, 1 ) );
            if ( !strcmp( option, "interactive" ) )
            {
                if ( strstr( buf, "srcport" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "srcport" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, ul.handle, prioparamawk ( buf , "srcport" , n ) );
                        system( buf2 );
                        ul.handle++;
                    }
                }
                if ( strstr( buf, "dstport" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "dstport" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, ul.handle, prioparamawk ( buf , "dstport" , n ) );
                        system( buf2 );
                        ul.handle++;
                    }
                }
                if ( strstr( buf, "srcip" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "srcip" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, ul.handle, prioparamawk ( buf , "srcip" , n ) );
                        system( buf2 );
                        ul.handle++;
                    }
                }
                if ( strstr( buf, "dstip" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "dstip" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, ul.handle, prioparamawk ( buf , "dstip" , n ) );
                        system( buf2 );
                        ul.handle++;
                    }
                }
                if ( strstr( buf, "u32" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "u32" , n ) ; n++ )
                    {
                        sprintf( buf2 , "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x %s flowid 1:100", dev, ul.handle, prioparamawk ( buf , "u32" , n ) );
                        system( buf2 );
                        ul.handle++;
                    }
                }
            }
        }
    }
    if ( router_control )
    {
        if ( use.imq )
        {
	    if ( dl.linkspeed )
	    {
		sprintf( buf, "iptables -t mangle -A niceshaper_dl -i %s -d %s -j RETURN", iface[ 0 ].dev, iface[ 0 ].ip );
        	system( buf );
    	    }
	    if ( ul.linkspeed )
	    {
	        sprintf( buf, "iptables -t mangle -A niceshaper_ul -o %s -s %s -j IMQ --todev 0", iface[ 0 ].dev, iface[ 0 ].ip );
    	        system( buf );
    	    }
	}
        else if ( use.mark )
        {
	    if ( dl.linkspeed )
	    {
	        sprintf( buf, "iptables -t mangle -A niceshaper_dl -i %s -d %s -j RETURN", iface[ 0 ].dev, iface[ 0 ].ip );
	        system( buf );
	    }
	    if ( ul.linkspeed )
	    {
                sprintf( buf, "iptables -t mangle -A niceshaper_ul -o %s -s %s -j MARK --set-mark %d", iface[ 0 ].dev, iface[ 0 ].ip, ul.handle );
	        system( buf );
	    }
        }
        else if ( use.none )
        {
	    if ( dl.linkspeed )
	    {
	        sprintf( buf, "iptables -t mangle -A niceshaper_dl -i %s -d %s -j RETURN", iface[ 0 ].dev, iface[ 0 ].ip );
                system( buf );
	    }
	    if ( ul.linkspeed )
	    {
                sprintf( buf, "iptables -t mangle -A niceshaper_ul -o %s -s %s -j RETURN", iface[ 0 ].dev, iface[ 0 ].ip );
                system( buf );
	    }
        }
    }
    n = 1;
    while ( n <= users )
    {
        if ( use.imq )
        {
            if ( dl.linkspeed )
            {
                sprintf( buf, "iptables -t mangle -A niceshaper_dl -o %s -d %s -j IMQ --todev 1", user[ n ].dev, user[ n ].ip );
                system( buf );
            }
            if ( ul.linkspeed )
            {
                sprintf( buf, "iptables -t mangle -A niceshaper_ul -i %s -s %s -j IMQ --todev 0", user[ n ].dev, user[ n ].ip );
                system( buf );
            }
        }
        else if ( use.mark )
        {
            if ( dl.linkspeed )
            {
                sprintf( buf, "iptables -t mangle -A niceshaper_dl -o %s -d %s -j RETURN", user[ n ].dev, user[ n ].ip );
                system( buf );
            }
            if ( ul.linkspeed )
            {
                sprintf( buf, "iptables -t mangle -A niceshaper_ul -i %s -s %s -j MARK --set-mark %d", user[ n ].dev, user[ n ].ip, ul.handle + n );
                system( buf );
            }
        }
        else if ( use.none )
        {
            if ( dl.linkspeed )
            {
                sprintf( buf, "iptables -t mangle -A niceshaper_dl -o %s -d %s -j RETURN", user[ n ].dev, user[ n ].ip );
                system( buf );
            }
            if ( ul.linkspeed )
            {
                sprintf( buf, "iptables -t mangle -A niceshaper_ul -i %s -s %s -j RETURN", user[ n ].dev, user[ n ].ip );
                system( buf );
            }
        }
        n++;
    }
    n = 0;
    if ( use.mark && ul.interactive )
    {
        fseek( fp , ulpos.set , SEEK_SET );
        while ( ftell( fp ) < ulpos.end )
        {
            fgets( buf , 255 , fp );
	    hash( buf , "#" );
            strcpy ( option , awk ( buf , 1 ) );
            if ( !strcmp ( option , "interactive" ) )
            {
                if ( strstr( buf, "srcport" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "srcport" , n ) ; n++ )
                    {
                        sprintf( buf2, "iptables -t mangle -A niceshaper_ul -p tcp --sport %s -j MARK --set-mark %d", awk( prioparamawk ( buf , "srcport" , n ) , 5 ) , 2048 );
                        system( buf2 );
                        sprintf( buf2, "iptables -t mangle -A niceshaper_ul -p udp --sport %s -j MARK --set-mark %d", awk( prioparamawk ( buf , "srcport" , n ) , 5 ) , 2048 );
                        system( buf2 );
                    }
                }
                if ( strstr( buf, "dstport" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "dstport" , n ) ; n++ )
                    {
                        sprintf( buf2, "iptables -t mangle -A niceshaper_ul -p tcp --dport %s -j MARK --set-mark %d", awk( prioparamawk ( buf , "dstport" , n ) , 5 ) , 2048 );
                        system( buf2 );
                        sprintf( buf2, "iptables -t mangle -A niceshaper_ul -p udp --dport %s -j MARK --set-mark %d", awk( prioparamawk ( buf , "dstport" , n ) , 5 ) , 2048 );
                        system( buf2 );
                    }
                }
                if ( strstr( buf, "srcip" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "srcip" , n ) ; n++ )
                    {
                        sprintf( buf2, "iptables -t mangle -A niceshaper_ul -s %s -j MARK --set-mark %d", awk( prioparamawk ( buf , "srcip" , n ) , 5 ) , 2048 );
                        system( buf2 );
                    }
                }
                if ( strstr( buf, "dstip" ) )
                {
                    for ( n = 1 ; prioparamawk ( buf , "dstip" , n ) ; n++ )
                    {
                        sprintf( buf2, "iptables -t mangle -A niceshaper_ul -d %s -j MARK --set-mark %d", awk( prioparamawk ( buf , "dstip" , n ) , 5 ) , 2048 );
                        system( buf2 );
                    }
                }
            }
        }
    }
    fclose ( fp );
}

bool do_not_shape ( char srcarg1[] , char srcarg2[] )
{
    int n, m;
    char buf[ 255 ] , arg1[ 32 ] , arg2[ 32 ] , addr1[ 16 ] = "", mssk1[ 16 ] = "" , addr2[ 16 ] = "", mssk2[ 16 ] = "";

    strcpy( arg1 , srcarg1 );
    strcpy( arg2 , srcarg2 );
    n = 0; 
    while ( strcmp( iface[ n ].dev, "EOF" ) )
    {
	if ( !strcmp( iface[ n ].dev , arg1 ) ) strcpy( arg1 , iface[ n ].ip );
	if ( !strcmp( iface[ n ].dev , arg2 ) ) strcpy( arg2 , iface[ n ].ip );
	n++;
    }
    if ( !split ( addr1 , mssk1 , arg1 ) || !split ( addr2 , mssk2 , arg2 ) ) return false; 
    n = 0; 
    while ( strcmp( iface[ n ].dev, "EOF" ) )
    {
	if ( !strcmp( iface[ n ].ip , addr2 ) )
	{
	    strcpy( buf , arg1 );
	    strcpy( arg1 , arg2 );
	    strcpy( arg2 , buf );
	    split ( addr1 , mssk1 , arg1 );
	    split ( addr2 , mssk2 , arg2 );
	}
	n++;
    }	
    n = 0;
    while ( strcmp( iface[ n ].dev, "EOF" ) )
    {
	if ( !strcmp( iface[ n ].ip , addr1 ) )
	{
	    if ( strcmp( mssk1 , "255.255.255.255" ) ) { printf("Do not use mask with your router IP:%s\n" , arg1 ); return false; }
	    m = 1;
	    while ( strcmp( iface[ m ].dev, "EOF" ) )
	    {
	        if ( innetwrk ( iface[ m ].ip , iface[ m ].mask , addr2 , mssk2 ) )
		{
		    if ( dl.linkspeed )
                    {
                        sprintf( buf, "iptables -t mangle -I niceshaper_dl -o %s -s %s -d %s/%s -j RETURN", iface[ m ].dev, addr1, addr2, mssk2 );
                        system( buf );
		    }
                    if ( ul.linkspeed )
                    {
                        sprintf( buf, "iptables -t mangle -I niceshaper_ul -i %s -s %s/%s -d %s -j RETURN", iface[ m ].dev, addr2, mssk2, addr1 );
                        system( buf );
                    }
		    if ( !use.imq && dl.linkspeed )
    		    {
		        sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32 match ip src %s match ip dst %s/%d flowid 1:1", iface[ m ].dev, dl.handle, addr1, addr2, dotobit( mssk2 ) );
            		system( buf );
		        dl.handle++;
		    }	                
                    return true;
		}
		m++;
	    }
	}
	n++;    
    }
    n = 0;
    while ( strcmp( iface[ n ].dev, "EOF" ) )
    {
	if ( innetwrk( iface[ n ].ip , iface[ n ].mask , addr1 , mssk1 ) )
	{
	    m = 1;
	    while ( strcmp( iface[ m ].dev, "EOF" ) )
	    {
		if ( innetwrk( iface[ m ].ip , iface[ m ].mask , addr2 , mssk2 ) )
		{
                    if ( dl.linkspeed )
                    {
                        sprintf( buf, "iptables -t mangle -I niceshaper_dl -o %s -s %s/%s -d %s/%s -j RETURN", iface[ m ].dev, addr1, mssk1, addr2, mssk2 );
                        system( buf );
			sprintf( buf, "iptables -t mangle -I niceshaper_dl -o %s -s %s/%s -d %s/%s -j RETURN", iface[ n ].dev, addr2, mssk2, addr1, mssk1 );
                        system( buf );
                    }
		    if ( ul.linkspeed )
                    {
                        sprintf( buf, "iptables -t mangle -I niceshaper_ul -i %s -s %s/%s -d %s/%s -j RETURN", iface[ n ].dev, addr1, mssk1, addr2, mssk2 );
                        system( buf );
	                sprintf( buf, "iptables -t mangle -I niceshaper_ul -i %s -s %s/%s -d %s/%s -j RETURN", iface[ m ].dev, addr2, mssk2, addr1, mssk1 );
	                system( buf );

                    }
		    if ( !use.imq && dl.linkspeed ) 
		    {
		        sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32 match ip src %s/%d match ip dst %s/%d flowid 1:1", iface[ m ].dev, dl.handle, addr1, dotobit( mssk1 ), addr2, dotobit( mssk2 ) );
                	system( buf );
                	dl.handle++;
                	sprintf( buf, "tc filter add dev %s protocol ip parent 1:0 prio 10 handle 800::%x u32 match ip src %s/%d match ip dst %s/%d flowid 1:1", iface[ n ].dev, dl.handle, addr2, dotobit( mssk2 ), addr1, dotobit( mssk1 ) );
                	system( buf );
                	dl.handle++;
		    }
		    return true;
		}
		m++;
	    }
	}
	n++;
    }
    return false;
}

bool innetwrk ( char addr1 [] , char mssk1 [] , char addr2 [] , char mssk2 [] )
{
    unsigned long usaddr1 , usmssk1 , usaddr2 , usmssk2;
    usaddr1 = ntohl( inet_addr( addr1 ) );
    usmssk1 = ntohl( inet_addr( mssk1 ) );
    usaddr2 = ntohl( inet_addr( addr2 ) );
    usmssk2 = ntohl( inet_addr( mssk2 ) );
    if ( ( ( usaddr1 & usmssk1 ) <= ( usaddr2 & usmssk2 ) ) && ( ( ( usaddr1 & usmssk1 ) | ~usmssk1 ) >= ( ( usaddr2 & usmssk2 ) | ~usmssk2 ) ) ) return true;
    else return false;
}
int dotobit ( char mask [] )
{
    unsigned long addr;
    int n, bit;

    addr = ntohl ( inet_addr ( mask ) );
    for ( n = 0 , bit = 0 ; n < 32 ; n++ ) bit += ( addr >> n ) & 1;
    return bit;
}
bool bitodot ( char mask [] , int arg )
{
    struct in_addr netwrk;
    int n, m;
    
    if ( arg < 0 || arg > 32 ) return false;
    for ( m = 0, n = 0 ; n < arg ; n++ ) m += 1 << ( 31 - n );
    netwrk.s_addr = htonl( m );
    strcpy( mask, inet_ntoa( netwrk ) );
    mask[ strlen( mask ) ] = '\0';
    return true;
}

long int unitconvert ( char arg[] , unittype resunit )
{
    unsigned long int result;

    if ( strstr( arg, "kbit" ) ) result = atol( arg ) * 1024;
    else if ( strstr( arg, "mbit" ) ) result = atol( arg ) * 1048576;
    else if ( strstr( arg, "bit" ) ) result = atol( arg );
    else if ( strstr( arg, "kbps" ) ) result = atol( arg ) * 8192;
    else if ( strstr( arg, "mbps" ) ) result = atol( arg ) * 8388608;
    else if ( strstr( arg, "bps" ) ) result = atol( arg ) * 8;
    else result =  atol( arg ) ;
    result = result / resunit;
    return result;
}

long int csubc ( char num[], char dec[] )
{
    char a[ 2 ], b[ 2 ];
    int m, n, c, i;
    int d1, d2;
    long int back = 0;
    d1 = strlen( num );
    d2 = strlen( dec );
    if ( d1 < d2 ) return 0;
    for ( i = d1;i >= 1;--i )
    {
        a[ 0 ] = num[ i - 1 ];
        a[ 1 ] = 0;
        m = atoi( a );
        b[ 0 ] = dec[ i - 1 - ( d1 - d2 ) ];
        b[ 1 ] = 0;
        if ( ( d1 - d2 ) >= i ) b[ 0 ] = 0;
        n = atoi( b );
        if ( ( m - n ) < 0 )
        {
            m += 10;
            a[ 0 ] = num[ i - 2 ];
            a[ 1 ] = 0;
            c = atoi( a );
            c--;
            num[ i - 2 ] = 48 + c;
        }
        back = back + ( m - n ) * ( power( 10, strlen( num ) - i ) );
    }
    return back;
}

char *awk ( char param[] , unsigned int word )
{
    unsigned int n, aku;
    char buf[ 128 ];
    static char result[ 128 ];

    aku = 0;
    strcpy( buf , "" );
    strcpy( result , "" );
    for ( n = 0 ; n + 1 < strlen( param ) ; n++ )
    {
	if ( ( param[ n ] == 32 || param[ n ] == 9 ) && ( param[ n + 1 ] != 32 && param[ n + 1 ] != 9 ) ) aku++;
	if ( n == 0 && param[ 0 ] != 32 && param[ 0 ] != 9 ) aku++;
	if ( aku == word ) 
	{
	    if ( n == 0 && param[ 0 ] != 32 && param[ 0 ] != 9 ) strcpy( buf, param ); 
	    else strcpy( buf, &(param)[ n + 1 ] ); 
	    n = strlen( param );
	}    
    }	
    for ( n = 0 ; n < strlen( buf ) ; n++ )
    {
	if ( buf[ n ] == 32 || buf[ n ] == 9 || buf[ n ] == 10 ) 
	{
	    buf[ n ] = '\0';
	    n = strlen( buf );
	}
    }
    strcpy( result , buf );
    return result;
}

char *prioparamawk ( char argstring[] , char param[] , unsigned int word )
{
    static char result[ 128 ];
    char buf[ 256 ];
    unsigned long int n;

    if ( word == 0 ) return 0;
    if ( !strstr( argstring , param ) ) return 0;
    strcpy ( buf , &( strstr ( argstring , param ) )[strlen(param)] );
    if ( strstr ( buf , "srcport" ) ) buf[ strlen( buf ) - strlen( strstr( buf, "srcport" ) ) ] = '\0';
    if ( strstr ( buf , "dstport" ) ) buf[ strlen( buf ) - strlen( strstr( buf, "dstport" ) ) ] = '\0';
    if ( strstr ( buf , "srcip" ) ) buf[ strlen( buf ) - strlen( strstr( buf, "srcip" ) ) ] = '\0';
    if ( strstr ( buf , "dstip" ) ) buf[ strlen( buf ) - strlen( strstr( buf, "dstip" ) ) ] = '\0';
    if ( strstr ( buf , "u32" ) ) buf[ strlen( buf ) - strlen( strstr( buf, "u32" ) ) ] = '\0';
    for ( n = 0 ; n <= strlen( buf ) ; n++ )
    {
        if ( word == 1 ) break;
        if ( buf[ n ] == 44 ) word--;
    }
    if ( word > 1 ) return 0;
    strcpy ( result , &( buf )[ n ] );
    if ( strstr( result, "," ) ) result[ strlen( result ) - strlen( strstr( result, "," ) ) ] = '\0';
    strcpy ( result , &( result )[ strspn( result , " \t" ) ] );
    result[ strlen( result ) ] = '\0';
    strcpy( buf , result );
    if ( !strcmp ( param , "srcport" ) )
    {
        if ( valid_port ( atoi ( buf ) ) ) sprintf( result , "u32 match ip sport %d 0xffff" , atoi ( buf ) );
        else return 0;
    }
    else if ( !strcmp ( param , "dstport" ) )
    {
        if ( valid_port ( atoi ( buf ) ) ) sprintf( result , "u32 match ip dport %d 0xffff" , atoi ( buf ) );
        else return 0;
    }
    else if ( !strcmp ( param , "srcip" ) )
    {
        if ( valid_ip ( buf ) ) sprintf( result , "u32 match ip src %s" , buf );
	else return 0;
    }
    else if ( !strcmp ( param , "dstip" ) )
    {
        if ( valid_ip ( buf ) ) sprintf( result , "u32 match ip dst %s" , buf );
        else return 0;
    }
    else if ( !strcmp ( param , "u32" ) ) sprintf ( result , " u32 %s" , buf );
    return result;
}

bool getip ( char netaddr[] , char dev[] )
{
    char buf[ 256 ];
    FILE *pp;
    
    strcpy ( netaddr , "" );
    strcpy ( buf , "" );
    sprintf( buf, "ip addr show dev %s" , dev );
    pp = popen( buf, "r" );
    while ( fgets( buf, 256, pp ) )
    {
	if ( !strcmp ( awk( buf , 1 ) , "inet" ) )
	{
	    strcpy( netaddr , awk( buf , 2 ) );
	    pclose( pp );
	    return true;
	}
    }
    pclose( pp );
    return false;
}

void iptohostname ( char hostname[] , char ipaddr[] )
{
    uint32_t addr;
    struct hostent *hp;
    strcpy ( hostname , "" );
    addr = inet_addr ( ipaddr );
    hp = gethostbyaddr( ( char * ) & addr, sizeof ( addr ), AF_INET );
    if ( hp == NULL ) strcpy( hostname , ipaddr );
    else strcpy( hostname , hp->h_name );
}

bool split ( char ipaddr [] , char ipmask [] , char arg [] ) 
{
    strcpy ( ipaddr , "" );
    strcpy ( ipmask , "" );
    if ( strstr( arg , "/" ) )
    {
	if ( strcspn( arg , "/" ) > 15 ) return false;
	if ( strlen( &strstr( arg , "/" )[1] ) > 15 ) return false;
	strncpy( ipaddr , arg , strcspn( arg , "/" ) );
	strncpy( ipmask , &strstr( arg , "/" )[1] , 15);
	ipaddr[ strcspn( arg , "/" ) ] = '\0'; 
	ipmask[ strlen( &strstr( arg , "/" )[ 1 ] ) ]='\0';
    }
    else 
    {
    	if ( strlen( arg ) > 15 ) return false;
	strncpy( ipaddr , arg , strlen( arg ) );
	strcpy( ipmask , "255.255.255.255" );
	ipaddr[ strlen( arg ) ] = '\0';
        ipmask[ 15 ] = '\0'; 

    } 
    if ( !valid_ip( ipaddr ) ) return false;
    if ( !valid_mask( ipmask ) ) 
    {
        if ( strlen( ipmask ) == 1 || strlen( ipmask ) == 2 )
	{
    	    if ( !bitodot( ipmask , atoi ( ipmask ) ) ) return false;
	}
    }
    return true;
}

bool valid_dev ( char dev[] )
{
    if ( strlen( dev ) != 4 && strlen( dev ) != 5 ) return false;
    if ( dev[ 3 ] < 48 || dev[ 3 ] > 57 ) return false;
    if ( dev[ 4 ] != 0 && dev[ 4 ] != 9 && dev[ 4 ] != 10 && dev[ 4 ] != 32 && ( dev[ 4 ] < 48 || dev[ 4 ] > 57 ) ) return false;
    if ( dev[ 0 ] == 101 && dev[ 1 ] == 116 && dev[ 2 ] == 104 ) return true;
    if ( dev[ 0 ] == 112 && dev[ 1 ] == 112 && dev[ 2 ] == 112 ) return true;
    return false;
}

bool valid_ip ( char ipaddr[] )
{
    struct in_addr inaddr;
    if ( !inet_aton( ipaddr , &inaddr ) ) return false;
    if ( strcmp( ipaddr , inet_ntoa (inaddr) )) return false;
    return true;
}

bool valid_mask ( char ipmask[] )
{
    unsigned long addr;
		
    if ( !valid_ip( ipmask ) ) return false;
    addr = htonl ( inet_addr ( ipmask ) );
    for ( int n = 1 ; n < 32 ; n++ ) if ( ( ( addr >> n ) & 1 ) == 0 && ( ( addr >> n - 1 ) & 1 ) == 1 ) return false;
    return true;
}

bool valid_port ( int tcpport )
{
    if ( tcpport >= 1 && tcpport <= 65536 ) return true;
    else return false;
}

bool valid_whiteline ( char arg[] )
{
    for ( unsigned int n = 0 ; n < strlen( arg ) ; n++ )
    {
	if ( arg[ n ] != ' ' && arg[ n ] != '\t' && arg[ n ] != '\n' ) return false;
    }
    return true; 
}

void trim ( char buf[] )
{
    unsigned int n;
    for ( n = strlen( buf ) - 1; n >= 0 ; n-- )
    {
	if ( buf[ n ] == 9 || buf[ n ] == 10 || buf[ n ] == 32 ) buf[ n ] = 0;
	else return;
    }
}

bool hash ( char buf[] , char mark[] )
{
    buf[ strcspn( buf, mark )] = '\0';
    return true;
}

long int power( int arg , int inc )
{
    int result = 1;
    for ( int n = 1; n <= inc ; n++ ) result = result * arg;
    return result;
}

void help ()
{
    printf( "\n\tNiceshaper version:%s\n", version );
    printf( "\thttp://www.niceshaper.mikule.net\n" );
    printf( "\tPlease usage: niceshaper {start|stop|restart|stats}\n\n" );
}
